﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        Dictionary<int, Rectangle> _captionBounds; 
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            _captionBounds = new Dictionary<int, Rectangle>();

            var dt = new DataTable();
            dt.Columns.Add("A");
            dt.Columns.Add("B");
            dt.Columns.Add("C");
            dt.Columns.Add("D");
            dt.Columns.Add("E");

            for (int i = 0; i < 100; i++)
            {
                dt.Rows.Add(new object[] { $"A{i}", $"B{i}", $"C{i}", $"D{i}" ,$"E{i}"});
            }
            c1TrueDBGrid1.DataSource = dt;
        }

        private void c1TrueDBGrid1_Paint(object sender, PaintEventArgs e)
        {
            var gridObject = c1TrueDBGrid1.AccessibilityObject;
            if (gridObject != null && gridObject.GetChildCount() > 0)
            {
                var viewObject = gridObject.GetChild(0);
                if (viewObject != null && viewObject.Role == AccessibleRole.Pane && viewObject.GetChildCount() > 0)
                {
                    var rowHeaderObject = viewObject.GetChild(0);
                    if (rowHeaderObject != null && rowHeaderObject.Role == AccessibleRole.Row && rowHeaderObject.GetChildCount() > 0)
                    {                     
                        for (int index = 0; index < rowHeaderObject.GetChildCount(); index++)
                        {
                            var headerCellObject = rowHeaderObject.GetChild(index);
                            if (headerCellObject != null && headerCellObject.Role == AccessibleRole.ColumnHeader)
                            {
                                _captionBounds[index] = headerCellObject.Bounds;
                            }
                        }
                    }
                }
            }
        }
    }
}
